##################################
# Ma bibliotheque pour la tomographie
# Run envoie un jeu d'essai
##################################
# print_mat(T) affiche lisiblement un tableau 2D
# somme_liste(L) retourne la somme des entiers
#      constituant la liste L
# extract_col(T,j) retourne la liste L correspondant
#      a la colonne j du tableau T
# somme_li(T) retourne la liste des sommes par lignes
# somme_col(T) retourne la liste des sommes par colones
# compatl(L1,L2) retorune vrai quand les sommes des entiers
#      des listes sont égales
# MGC(L) retourne un tableau dont L est la projection
#   tomographique horizontale, dont les 1 sont à gauche des 0
# permut(L)[0] retourne la liste triée par ordre décroissant
# permut(L)[1] retourne la permutation correspondante
#########################################

def print_mat(T):
    for i in range(len(T)):
        print(T[i])

def somme_liste(L):
    rep=0
    for i in range(len(L)):
        rep=rep+L[i]
    return rep

def extract_col(T,j):
    rep=[]
    for i in range(len(T)):
        rep.append(T[i][j])
    return rep


def som_li(T):
    rep=[]
    for i in range(len(T)):
        rep.append(somme_liste(T[i]))
    return rep

def som_col(T):
    rep=[]
    for j in range(len(T)):
        rep.append(somme_liste(extract_col(T,j)))
    return rep


def compatl(L1,L2):
    ans=0
    for i in range(len(L1)):
        ans=ans + L1[i]
    rep=0
    for i in range(len(L2)):
        rep=rep + L2[i]
    return ans==rep

def MGC(L):
    n=len(L)
    rep=[]
    for i in range(n):
        ans=[]
        k=0
        while k < L[i]:
            ans.append(1)
            k=k+1
        while k < n:
            ans.append(0)
            k=k+1
        rep.append(ans)
    return rep
            
def permut(L):
    perm=[i for i in range(len(L))]
    for k in range(len(L)):
        for j in range(k+1,len(L)):
            if L[j]>L[k]:
                rep=L[j]
                L[j]=L[k]
                L[k]=rep
                ans=perm[j]
                perm[j]=perm[k]
                perm[k]=ans
    return (L,perm)

TE=[]
for i in range(10):
    rep=[]
    for j in range(10):
        rep.append((i+j)%2)
    TE.append(rep)
TE[3][3]=1
TE[2][5]=0
TE[7][6]=0
TE[7][8]=0

print("print_mat(TE): ")

print_mat(TE)

print("som_li(TE) ",som_li(TE))

print("som_col(TE) ",som_col(TE))

print("compatl(som_li(TE),som_col(TE)): ", compatl(som_li(TE),som_col(TE)))

print("print_mat(MGC(som_li(TE))): ")

print_mat(MGC(som_li(TE)))

print("permut([12,14,16,10,11,14]): ", permut([12,14,16,10,11,14]))
